/**
 * WEBLAB: Service oriented integration platform for media mining and intelligence applications
 * 
 * Copyright (C) 2004 - 2009 EADS DEFENCE AND SECURITY SYSTEMS
 * 
 * This library is free software; you can redistribute it and/or modify it under the terms of
 * the GNU Lesser General Public License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License along with this
 * library; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */

package org.ow2.weblab.services;

import java.io.File;

import org.springframework.beans.factory.xml.XmlBeanFactory;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.FileSystemResource;
import org.springframework.core.io.Resource;

/**
 * @deprecated use weblab-client instead (org.ow2.weblab.components.weblab-client)
 */
public class BeansManager {

	private XmlBeanFactory factory; 
	
	protected String pathToConfiguration;
	
	public String getPathToConfiguration() {
		return pathToConfiguration;
	}

	public void setPathToConfiguration(String pathToConfiguration) {
		this.pathToConfiguration = pathToConfiguration;
	}
	
	public static <T extends BeansManager> T getInstance(String path){
		
		Resource r = new ClassPathResource(path);
		if (!r.exists()){
			r = new FileSystemResource(new File(path));
		}
		XmlBeanFactory factory = new XmlBeanFactory(r);
		
		try {
			BeansManager instance = factory.getBean("redirectionManager", BeansManager.class);
			if (instance != null){
				// activate redirection
				String redirectionpath = instance.getPathToConfiguration(); 
				FileSystemResource fsr = new FileSystemResource(new File(redirectionpath));
				factory = new XmlBeanFactory(fsr);
			}
		}catch(Exception e){
			// end of redirection	
		}
		BeansManager bm = new BeansManager();
		bm.factory = factory;
		
		return (T)bm;
	}
	
	public <T> T get(String name, Class<T> clazz){
		return factory.getBean(name, clazz);
	}
}
